#include <stdio.h>
#include <math.h>
double a8[8],b8[8];
double rc,dc,hs2, pi,cx,cy,scale;
int    n1,n2;
main(int ac, char **av)
{
  int    i,j,k,type;
  double x,y,a1,a2,a3,d1,d2,d3,m1,m2;
  if(ac<5){
     printf("\n\t****** produce 3*3 matrix's ra &dec    2014,12 *****\n");
     printf("\n\tUsage: vv ra dec col row scale [!]\n");
     printf("\n\tEx: vv 1.5 70.2 8640 8200 0.455\n");
     printf("\n\t ! BOK case, else Schmidt_system");
     printf("\n\tcenter:    ra(hour); dec(degree)");
     printf("\n\t           -89 < dec < 89");
     printf("\n\tpic_size:  X_len(pixel); Y_len(pixel)");
     printf("\n\tscale:     arcsec/pixel\n");
     printf("\n\tassume: CCD well mounted, no slope angle");
     printf("\n\toutput: corner & mid_edge's ra & dec\n\n");
     exit(0);
  }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  sscanf(av[1],"%lf",&rc);
  while(rc>=24.)rc-=24.; while(rc<0.)rc+=24.;
  sscanf(av[2],"%lf",&dc);
  if(dc>89.)dc=89.;  if(dc<-89.)dc=-89.;
  sscanf(av[3],"%d",&n1);
  sscanf(av[4],"%d",&n2);
  sscanf(av[5],"%lf",&scale);
  type=1; if(ac>6)type=2;
  printf("type: %d ",type);
  if(type==1)printf("\tSchmidt system\n"); else printf("\tBOK case\n");
  m1=(n1+1)/2.; m2=(n2+1)/2.;

  rc*=cx; dc*=cy; a8[6]=rc; a8[7]=dc;  
  hs2=(3600.*180./pi)/scale;                 
  b8[0]=-hs2; b8[1]=b8[2]=0; b8[3]=-b8[0]; b8[4]=m1; b8[5]=m2;
  xytoad(b8,a8);
   
  x= 1;    y=n2;     xy_rad(rc,dc,x,y,&a1,&d1,type,0);
  x=m1;    y=n2;     xy_rad(rc,dc,x,y,&a2,&d2,type,0);
  x=n1;    y=n2;     xy_rad(rc,dc,x,y,&a3,&d3,type,0);
  printf("%9.5lf%10.5lf %12.5lf%10.5lf %12.5lf%10.5lf\n",a1,d1,a2,d2,a3,d3);
  x= 1;    y=m2;     xy_rad(rc,dc,x,y,&a1,&d1,type,0);
  x=m1;    y=m2;     xy_rad(rc,dc,x,y,&a2,&d2,type,0);
  x=n1;    y=m2;     xy_rad(rc,dc,x,y,&a3,&d3,type,0);
  printf("%9.5lf%10.5lf %12.5lf%10.5lf %12.5lf%10.5lf\n",a1,d1,a2,d2,a3,d3);
  x= 1;    y= 1;     xy_rad(rc,dc,x,y,&a1,&d1,type,0);
  x=m1;    y= 1;     xy_rad(rc,dc,x,y,&a2,&d2,type,0);
  x=n1;    y= 1;     xy_rad(rc,dc,x,y,&a3,&d3,type,0);
  printf("%9.5lf%10.5lf %12.5lf%10.5lf %12.5lf%10.5lf\n",a1,d1,a2,d2,a3,d3);
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);

    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}
